/*
 * ! SAP UI development toolkit for HTML5 (SAPUI5/OpenUI5)
 * (c) Copyright 2009-2015 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','./Dialog','./IconTabBar','./IconTabFilter','./P13nDialogRenderer','./library','sap/ui/core/EnabledPropagator','jquery.sap.xml'],function(q,D,I,a,P,l,E){"use strict";var b=D.extend("sap.m.P13nDialog",{metadata:{library:"sap.m",properties:{initialVisiblePanelType:{type:"sap.m.P13nPanelType",group:"Misc",defaultValue:null},showReset:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{panels:{type:"sap.m.P13nPanel",multiple:true,singularName:"panel",bindable:"bindable"}},events:{ok:{},cancel:{},reset:{}}}});E.apply(b.prototype,[true]);b.prototype.init=function(e){this.addStyleClass("sapMP13nDialog");D.prototype.init.apply(this,arguments);this._oResourceBundle=sap.ui.getCore().getLibraryResourceBundle("sap.m");this._initDialog()};b.prototype._initDialog=function(){var t=this;this.setContentWidth("50rem");this.setContentHeight("40rem");this.setTitle(this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS"));this.addButton(new sap.m.Button({text:this._oResourceBundle.getText("P13NDIALOG_OK"),press:function(){var p=null;var c=function(){p.onAfterNavigation();t.fireOk()};t.getContent().some(function(_){if(!_.onBeforeNavigation()){p=_;return true}});if(!p){t.fireOk();return}t.showValidationDialog(c,null)}}));this.addButton(new sap.m.Button({text:this._oResourceBundle.getText("P13NDIALOG_CANCEL"),press:function(){t.fireCancel()}}));this._oResetButton=new sap.m.Button({text:this._oResourceBundle.getText("P13NDIALOG_RESET"),visible:this.getShowReset(),press:function(){t.fireReset({})}});this.addButton(this._oResetButton)};b.prototype.setShowReset=function(s){this._oResetButton.setVisible(s)};b.prototype.addPanel=function(p){this.addAggregation("content",p);var B=this._mapPanelToButton(p);p.data(P.CSS_CLASS+"Button",B);if(this._getSegmentedButton()){this._getSegmentedButton().addButton(B)}this._setDialogTitleFor(p,this.getContent().length);this._setVisibilityOfPanel(p);return this};b.prototype.insertPanel=function(p,i){this.insertAggregation("content",p,i);var B=this._mapPanelToButton(p);p.data(P.CSS_CLASS+"Button",B);if(this._getSegmentedButton()){this._getSegmentedButton().insertButton(B,i)}this._setDialogTitleFor(p,this.getContent().length);this._setVisibilityOfPanel(p);return this};b.prototype.removePanel=function(p){p=this.removeAggregation("content",p);if(this._getSegmentedButton()){this._getSegmentedButton().removeButton(p&&p.data(P.CSS_CLASS+"Button"))}return p};b.prototype.removeAllPanels=function(){var p=this.removeAllAggregation("content");if(this._getSegmentedButton()){this._getSegmentedButton().removeAllButtons()}return p};b.prototype._getSegmentedButton=function(){if(this.getContent().length<2){return null}var t=this;if(!this.getSubHeader()||!this.getSubHeader().getContentLeft().length){this.setSubHeader(new sap.m.Bar({contentLeft:[new sap.m.SegmentedButton({select:function(e){var B=e.getParameter("button");t._switchPanel(B)},width:'100%'})]}));this._getSegmentedButton().addButton(this._getButtonByPanel(this.getContent()[0]))}return this.getSubHeader().getContentLeft()[0]};b.prototype.showValidationDialog=function(c,C){q.sap.require("sap.m.MessageBox");sap.m.MessageBox.show(sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_MESSAGE"),{icon:sap.m.MessageBox.Icon.WARNING,title:sap.ui.getCore().getLibraryResourceBundle("sap.m").getText("P13NDIALOG_VALIDATION_TITLE"),actions:[sap.m.MessageBox.Action.OK,sap.m.MessageBox.Action.CANCEL],onClose:function(A){if(A===sap.m.MessageBox.Action.OK){c()}else if(A===sap.m.MessageBox.Action.OK){C()}},styleClass:!!this.$().closest(".sapUiSizeCompact").length?"sapUiSizeCompact":""})};b.prototype._mapPanelToButton=function(p){if(!p){return null}var B=new sap.m.Button({type:sap.m.ButtonType.Default,text:p.getBindingPath("title")?"{"+p.getBindingPath("title")+"}":p.getTitle()});B.addDelegate({ontap:function(e){var o=e.srcControl;var c=this.getVisiblePanel();if(c&&c.onBeforeNavigation&&!c.onBeforeNavigation()){e.stopImmediatePropagation(true);var t=this;var C=function(){c.onAfterNavigation();if(t._getSegmentedButton()){t._getSegmentedButton().setSelectedButton(o)}t._switchPanel(o)};this.showValidationDialog(C,null)}}},true,this);B.setModel(p.getModel());return B};b.prototype._switchPanel=function(B){var p=this._getPanelByButton(B);this.setVerticalScrolling(p.getVerticalScrolling());this.getContent().forEach(function(o){if(o===p){o.setVisible(true)}else{o.setVisible(false)}},this);this.invalidate();this.rerender()};b.prototype.getVisiblePanel=function(){var p=null;this.getContent().some(function(o){if(o.getVisible()){p=o;return true}});return p};b.prototype._getPanelByButton=function(B){for(var i=0,p=this.getContent(),c=p.length;i<c;i++){if(p[i].data(P.CSS_CLASS+"Button")===B){return p[i]}}return null};b.prototype._getButtonByPanel=function(p){if(!p){return null}return p.data(P.CSS_CLASS+"Button")};b.prototype._setVisibilityOfOtherPanels=function(p,v){for(var i=0,c=this.getContent(),d=c.length;i<d;i++){if(c[i]===p){continue}c[i].setVisible(v)}return null};b.prototype._setVisibilityOfPanel=function(p){var v=this.getInitialVisiblePanelType()===p.getType()||this.getContent().length===1;p.setVisible(v);if(v){this._setVisibilityOfOtherPanels(p,false);var B=p.data(P.CSS_CLASS+"Button");if(this._getSegmentedButton()){this._getSegmentedButton().setSelectedButton(B)}this.setVerticalScrolling(p.getVerticalScrolling())}};b.prototype.onBeforeRendering=function(){if(this.getVisiblePanel()){this.setInitialVisiblePanelType(this.getVisiblePanel().getType())}D.prototype.onBeforeRendering.apply(this,arguments)};b.prototype._setDialogTitleFor=function(p,i){if(i>1){this.setTitle(this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS"));return}switch(p.getType()){case sap.m.P13nPanelType.filter:this.setTitle(this._oResourceBundle.getText("P13NDIALOG_TITLE_FILTER"));break;case sap.m.P13nPanelType.sort:this.setTitle(this._oResourceBundle.getText("P13NDIALOG_TITLE_SORT"));break;case sap.m.P13nPanelType.group:this.setTitle(this._oResourceBundle.getText("P13NDIALOG_TITLE_GROUP"));break;case sap.m.P13nPanelType.columns:this.setTitle(this._oResourceBundle.getText("P13NDIALOG_TITLE_COLUMNS"));break;default:this.setTitle(this._oResourceBundle.getText("P13NDIALOG_VIEW_SETTINGS"))}};b.prototype.exit=function(){D.prototype.exit.apply(this,arguments)};return b},true);
