/*!
 * SAP UI development toolkit for HTML5 (SAPUI5/OpenUI5)
 * (c) Copyright 2009-2015 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define(['jquery.sap.global','sap/ui/core/RenderManager','./Template','sap/ui/thirdparty/handlebars'],function(q,R,T,h){"use strict";var H=T.extend("sap.ui.core.tmpl.HandlebarsTemplate",{constructor:function(i,s){T.apply(this,arguments)}});T.registerType("text/x-handlebars-template","sap.ui.core.tmpl.HandlebarsTemplate");H.RENDER_HELPERS=(function(){var e=Handlebars.helpers["each"],w=Handlebars.helpers["with"],I=Handlebars.helpers["if"],u=Handlebars.helpers["unless"],r=new R();r.renderControl=function(c){this.writeControlData(c);this.writeClasses(c);this.writeStyles(c)};var o={"each":function(c,a){a=a||c;if(!a.hash.path){return e.apply(this,arguments)}else{var b=a.data.renderManager,d=a.data.rootControl,p=a.data.path,P=a.data.parentControl,s=(q.sap.startsWith(a.hash.path,"/")?"":(p||""))+a.hash.path,f=d.bindList(s),g=[],i;if(a.data){i=Handlebars.createFrame(a.data)}if(f){q.each(f,function(k,v){if(i){i.renderManager=b;i.rootControl=d;i.path=s+"/"+k+"/";i.parentControl=P}g.push(a.fn({},{data:i}))})}if(!P){return new Handlebars.SafeString(g.join(""))}}},"with":function(c,a){a=a||c;if(!a.hash.path){return w.apply(this,arguments)}},"if":function(c,a){a=a||c;if(!a.hash.path){return I.apply(this,arguments)}else{var b=a.data.rootControl,p=a.data.path,P=(q.sap.startsWith(a.hash.path,"/")?"":(p||""))+a.hash.path;if(P){var v=b.bindProp(P);if(v){return a.fn(this)}else{return a.inverse(this)}}}},"unless":function(c,a){a=a||c;if(!a.hash.path){return u.apply(this,arguments)}else{var b=a.data.rootControl,p=a.data.path,P=(q.sap.startsWith(a.hash.path,"/")?"":(p||""))+a.hash.path;if(P){var v=b.bindProp(P);if(!v){return a.fn(this)}else{return a.inverse(this)}}}},"text":function(c,a){a=a||c;var b=a.data.rootControl,p=a.data.path,P=(q.sap.startsWith(a.hash.path,"/")?"":(p||""))+a.hash.path;if(P){var v=b.bindProp(P);return v&&new Handlebars.SafeString(v)}else{throw new Error("The expression \"text\" requires the option \"path\"!")}},"element":function(c,a){a=a||c;var b=a.data.renderManager,d=a.data.rootControl,E=d.createDOMElement(a.hash,a.data.path),p=a.data.parentElement;if(a.fn){a.fn({},{data:{renderManager:b,rootControl:d,parentElement:E}})}if(p){p.addElement(E);return}return new Handlebars.SafeString(b.getHTML(E))},"control":function(c,a){a=a||c;var b=a.data.renderManager,C=a.data.control;if(C){return new Handlebars.SafeString(b.getHTML(C))}var d=a.data.rootControl,p=a.data.path,P=a.data.children,t=a.hash["sap-ui-type"],m=q.sap.getObject(t).getMetadata(),D=a.hash["sap-ui-default-aggregation"]||m.getDefaultAggregationName(),v=a.data.view;var f={};if(a.fn){a.fn({},{data:{rootControl:d,path:p,children:f,defaultAggregation:D,view:v}})}var s=q.extend({},a.hash);q.each(s,function(k,V){if(f[k]){delete s[k]}});var n=d.createControl(s,a.data.path,!!P,v);if(!q.isEmptyObject(f)){s=a.hash;var A=m.getAllAggregations();q.each(f,function(g,j){for(var i=0,l=j.length;i<l;i++){var k=j[i],x=A[g],M=x&&x.multiple;if(typeof s[g]==="string"){var B=sap.ui.base.ManagedObject.bindingParser(s[g],v&&v.getController());B.template=k;n.bindAggregation(g,B)}else{if(M){n.addAggregation(g,k)}else{n.setAggregation(g,k)}}}})}if(P){var g=a.hash["sap-ui-aggregation"]||a.data.defaultAggregation;P[g]=P[g]||[];P[g].push(n);return}return new Handlebars.SafeString(b.getHTML(n))},"property":function(c,a){a=a||c;var b=a.data.rootControl,m=b.getMetadata(),p=a.hash.name,g=m.getAllProperties()[p]._sGetter;return b[g]()},"aggregation":function(c,a){a=a||c;if(a.data.children){var A=a.hash.name;if(a.fn){var d=q.extend({},a.data,{defaultAggregation:A});a.fn({},{data:d})}}else{var b=a.data.renderManager,f=a.data.rootControl,m=f.getMetadata(),A=a.hash.name,g=m.getAllAggregations()[A]._sGetter,j=[];var C=f[g]();if(C){for(var i=0,l=C.length;i<l;i++){if(a.fn){j.push(a.fn({},{data:{renderManager:b,rootControl:f,control:C[i]}}))}else{j.push(b.getHTML(C[i]))}}}return new Handlebars.SafeString(j.join(""))}},"event":function(c,a){a=a||c},"controlData":function(c,a){a=a||c;var b=a.data.rootControl;return new Handlebars.SafeString(r.getHTML(b))}};return o}());H.prototype.createMetadata=function(){var t=this.getContent(),f=this._fnTemplate=this._fnTemplate||Handlebars.compile(t);var m={},j=sap.ui.core.tmpl.TemplateControl.getMetadata().getJSONKeys(),p=sap.ui.core.tmpl.TemplateControl.getMetadata().getAllPrivateAggregations();var o={"property":function(c,a){a=a||c;var n=a.hash.name;if(n&&n!=="id"&&!j[n]){m.properties=m.properties||{};m.properties[n]=q.extend({},{type:"string"},a.hash)}else{throw new Error("The property name \""+n+"\" is reserved.")}},"aggregation":function(c,a){a=a||c;var n=a.hash.name;if(n&&!j[n]&&!p[n]){a.hash.multiple=a.hash.multiple=="true";m.aggregations=m.aggregations||{};m.aggregations[n]=q.extend({},a.hash)}else{throw new Error("The aggregation name \""+n+"\" is reserved.")}},"event":function(c,a){a=a||c},"controlData":function(c,a){a=a||c;m._hasControlData=true}};q.each(["each","if","unless","with"],function(i,v){o[v]=function(){}});f({},{helpers:o});return m};H.prototype.createRenderer=function(v){var t=this.getContent(),f=this._fnTemplate=this._fnTemplate||Handlebars.compile(t);var r=function(a,c){var s=f(c.getContext()||{},{data:{renderManager:a,rootControl:c,view:v},helpers:H.RENDER_HELPERS});a.write(s)};return r};return H},true);
